



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Apache POI组件操作Excel，制作报表（二）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Apache POI组件操作Excel，制作报表（二）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 08:46:33 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>本文接<a href="http://sarin.iteye.com/blog/845035" rel="external nofollow noreferrer">上一篇</a>继续探究POI组件的使用。&nbsp;<br />&nbsp;&nbsp;&nbsp; 现在来看看Excel的基本设置问题，以2007为例，先从工作簿来说，设置列宽，因为生成表格列应该固定，而行是遍历生成的，所以可以在工作簿级别来设置列宽，那么可以如下来进行。&nbsp;<br />&nbsp;&nbsp;&nbsp; 首先是创建工作簿和工作表了：</p>
<div>
<ol><li>//&nbsp;创建Excel2007工作簿对象</li>
<li>XSSFWorkbook&nbsp;workbook2007&nbsp;=&nbsp;new&nbsp;XSSFWorkbook();</li>
<li>//&nbsp;创建工作表对象并命名</li>
<li>XSSFSheet&nbsp;sheet&nbsp;=&nbsp;workbook2007.createSheet("学生信息统计表");</li>
<li>之后是设置格式：</li>
<li>//&nbsp;设置行列的默认宽度和高度</li>
<li>sheet.setColumnWidth(0,&nbsp;32&nbsp;*&nbsp;80);//&nbsp;对A列设置宽度为80像素</li>
<li>sheet.setColumnWidth(1,&nbsp;32&nbsp;*&nbsp;80);</li>
<li>sheet.setColumnWidth(2,&nbsp;32&nbsp;*&nbsp;80);</li>
<li>sheet.setColumnWidth(3,&nbsp;32&nbsp;*&nbsp;80);</li>
<li>sheet.setColumnWidth(4,&nbsp;32&nbsp;*&nbsp;80);</li></ol>
</div>
<p>在这之前要先创建一个工作表sheet，然后就可以对每列设置列宽了。而行高一般针对不同的行有不同的设置，比如表头行，合计行，数据行等，那么分别设置会比较好。设置完列宽和行高，剩下就是对单元格的设置，比如居中，边框，字体等。设置好样式后将样式应用于所需要的单元格，就得到了整体的效果，比如：</p>
<div>
<ol><li>//&nbsp;创建样式</li>
<li>XSSFFont&nbsp;font&nbsp;=&nbsp;workbook2007.createFont();</li>
<li>XSSFCellStyle&nbsp;headerStyle&nbsp;=&nbsp;workbook2007.createCellStyle();</li>
<li>//&nbsp;设置垂直居中</li>
<li>headerStyle.setAlignment(HorizontalAlignment.CENTER);</li>
<li>headerStyle.setVerticalAlignment(VerticalAlignment.CENTER);</li>
<li>//&nbsp;设置边框</li>
<li>headerStyle.setBorderTop(BorderStyle.THIN);</li>
<li>headerStyle.setBorderBottom(BorderStyle.THIN);</li>
<li>headerStyle.setBorderLeft(BorderStyle.THIN);</li>
<li>headerStyle.setBorderRight(BorderStyle.THIN);</li>
<li>//&nbsp;字体加粗</li>
<li>font.setBold(true);</li>
<li>//&nbsp;设置长文本自动换行</li>
<li>headerStyle.setWrapText(true);</li>
<li>headerStyle.setFont(font);</li></ol>
</div>
<p>这里我们定义的是表头的样式，其中垂直居中时的设置要设置两次，而且方法名不同，要注意。边框就很简单了，上下左右设置四次，字体加粗就是布尔值设定了，之后是文本自动换行，意思就是在固定单元格长度不变时是否自动折行。然后将字体样式加入到单元格样式中即可。&nbsp;<br />&nbsp;&nbsp;&nbsp; 下面针对之前的例子设计表头，如下：</p>
<div>
<ol><li>//&nbsp;创建表头</li>
<li>XSSFRow&nbsp;headerRow&nbsp;=&nbsp;sheet.createRow(0);</li>
<li>headerRow.setHeightInPoints(25f);//&nbsp;设置行高度</li>
<li>XSSFCell&nbsp;nameHeader&nbsp;=&nbsp;headerRow.createCell(0);</li>
<li>nameHeader.setCellValue("姓名");</li>
<li>nameHeader.setCellStyle(headerStyle);</li>
<li>XSSFCell&nbsp;genderHeader&nbsp;=&nbsp;headerRow.createCell(1);</li>
<li>genderHeader.setCellValue("性别");</li>
<li>genderHeader.setCellStyle(headerStyle);</li>
<li>XSSFCell&nbsp;ageHeader&nbsp;=&nbsp;headerRow.createCell(2);</li>
<li>ageHeader.setCellValue("年龄");</li>
<li>ageHeader.setCellStyle(headerStyle);</li>
<li>XSSFCell&nbsp;classHeader&nbsp;=&nbsp;headerRow.createCell(3);</li>
<li>classHeader.setCellValue("班级");</li>
<li>classHeader.setCellStyle(headerStyle);</li>
<li>XSSFCell&nbsp;scoreHeader&nbsp;=&nbsp;headerRow.createCell(4);</li>
<li>scoreHeader.setCellValue("成绩");</li>
<li>scoreHeader.setCellStyle(headerStyle);</li></ol>
</div>
<p>这里的代码会有大段的重复，因为都是一个套路下来的，最后别忘加入样式就行了，这样表格头部就做好了。剩下的是遍历数据出行。</p>
<div>
<ol><li>for&nbsp;(int&nbsp;i&nbsp;=&nbsp;0;&nbsp;i&nbsp;&lt;&nbsp;studentList.size();&nbsp;i++)&nbsp;{</li>
<li>XSSFRow&nbsp;row&nbsp;=&nbsp;sheet.createRow(i&nbsp;+&nbsp;1);</li>
<li>row.setHeightInPoints(20f);</li>
<li>Student&nbsp;student&nbsp;=&nbsp;studentList.get(i);</li>
<li>XSSFCell&nbsp;nameCell&nbsp;=&nbsp;row.createCell(0);</li>
<li>nameCell.setCellValue(student.getName());</li>
<li>nameCell.setCellStyle(cellStyle);</li>
<li>XSSFCell&nbsp;genderCell&nbsp;=&nbsp;row.createCell(1);</li>
<li>genderCell.setCellValue(student.getGender());</li>
<li>genderCell.setCellStyle(cellStyle);</li>
<li>XSSFCell&nbsp;ageCell&nbsp;=&nbsp;row.createCell(2);</li>
<li>ageCell.setCellValue(student.getAge());</li>
<li>ageCell.setCellStyle(cellStyle);</li>
<li>XSSFCell&nbsp;classCell&nbsp;=&nbsp;row.createCell(3);</li>
<li>classCell.setCellValue(student.getSclass());</li>
<li>classCell.setCellStyle(cellStyle);</li>
<li>XSSFCell&nbsp;scoreCell&nbsp;=&nbsp;row.createCell(4);</li>
<li>scoreCell.setCellValue(student.getScore());</li>
<li>scoreCell.setCellStyle(cellStyle);</li>
<li>}</li></ol>
</div>
<p>用for循环就可以完成任务，需要注意的是循环变量仍然从0开始走，这是为了遍历集合的方便，而创建行就是从i+1开始走了，因为0行是表头，已经占用了。下面就是先设定行高，之后开始取值，赋值，设定格式，结构也很统一。&nbsp;<br />&nbsp;&nbsp;&nbsp; 完成遍历后，来看看合并，Excel中的合并单元格也是很常用的操作，比如本例中，将班级都设置成一班后，那么就想让班级这列合并，该如何操作呢？</p>
<div>
<ol><li>//&nbsp;合并班级</li>
<li>sheet.addMergedRegion(new&nbsp;CellRangeAddress(1,&nbsp;4,&nbsp;3,&nbsp;3));</li></ol>
</div>
<p>这是对sheet级别的操作，因为是在sheet上合并单元格，就是加一个合并的区域，这个区域接收四个参数，就是开始的行，结束的行，开始的列，结束的列，这个位置一般比较确定，或者用循环变量计算得出。班级，从第二行开始，第五行结束，对应索引是1，4，而列不变，就是在列上合并，就都是3即可。&nbsp;<br />&nbsp;&nbsp;&nbsp; 至此我们已经将数据遍历得出生成了Excel表格，设置了单元格样式也进行了合并，那么还有合计没有说，用合计可以直接设置公式，也可以程序计算好后直接填充，后者一般用于比较复杂的报表，就不用在POI中设置合并的位置，减少复杂度。结合本例，我们来计算平均年龄和成绩之和。如下：</p>
<div>
<ol><li>//&nbsp;数据分析行</li>
<li>int&nbsp;dadaRowNum&nbsp;=&nbsp;sheet.getLastRowNum();</li>
<li>XSSFRow&nbsp;totalRow&nbsp;=&nbsp;sheet.createRow(dadaRowNum&nbsp;+&nbsp;1);//&nbsp;获取已有的行数，加1再出新行</li>
<li>totalRow.setHeightInPoints(25f);</li>
<li>XSSFCell&nbsp;analyticsCell&nbsp;=&nbsp;totalRow.createCell(0);</li>
<li>analyticsCell.setCellValue("数据分析");</li>
<li>analyticsCell.setCellStyle(headerStyle);</li>
<li>XSSFCell&nbsp;avgAgeCell&nbsp;=&nbsp;totalRow.createCell(1);</li>
<li>avgAgeCell.setCellValue("平均年龄");</li>
<li>avgAgeCell.setCellStyle(headerStyle);</li>
<li>XSSFCell&nbsp;avgAgeValueCell&nbsp;=&nbsp;totalRow.createCell(2);</li>
<li>avgAgeValueCell.setCellStyle(headerStyle);</li>
<li>avgAgeValueCell.setCellFormula("AVERAGE(C2:C"&nbsp;+&nbsp;(dadaRowNum&nbsp;+&nbsp;1)&nbsp;+&nbsp;")");</li>
<li>XSSFCell&nbsp;sumScoreCell&nbsp;=&nbsp;totalRow.createCell(3);</li>
<li>sumScoreCell.setCellValue("总成绩");</li>
<li>sumScoreCell.setCellStyle(headerStyle);</li>
<li>XSSFCell&nbsp;sumScoreValueCell&nbsp;=&nbsp;totalRow.createCell(4);</li>
<li>sumScoreValueCell.setCellStyle(headerStyle);</li>
<li>sumScoreValueCell.setCellFormula("SUM(E2:E"&nbsp;+&nbsp;(dadaRowNum&nbsp;+&nbsp;1)&nbsp;+&nbsp;")");</li></ol>
</div>
<p>这里使用Excel函数的时候我们已经知道数据所在的位置，就直接使用了单元格的代号进行运算了，要注意使用公式时的方法中不用写=号，POI会自动为我们添加进去，这里就直接写公式的内容即可。在实际中可能会有动态计算的任务，那么就根据业务复杂度来选择是用Excel公式进行运算还是程序运算好后直接赋值显示。&nbsp;<br />&nbsp;&nbsp;&nbsp; 最后是生成文件的步骤，这已经介绍过了，都很简单：</p>
<div>
<ol><li>//&nbsp;生成文件</li>
<li>File&nbsp;file&nbsp;=&nbsp;new&nbsp;File(filePath);</li>
<li>OutputStream&nbsp;os&nbsp;=&nbsp;null;</li>
<li>try&nbsp;{</li>
<li>os&nbsp;=&nbsp;new&nbsp;FileOutputStream(file);</li>
<li>workbook2007.write(os);</li>
<li>}&nbsp;catch&nbsp;(IOException&nbsp;e)&nbsp;{</li>
<li>e.printStackTrace();</li>
<li>}&nbsp;finally&nbsp;{</li>
<li>if&nbsp;(os&nbsp;!=&nbsp;null)&nbsp;{</li>
<li>try&nbsp;{</li>
<li>os.close();</li>
<li>}&nbsp;catch&nbsp;(IOException&nbsp;e)&nbsp;{</li>
<li>}</li>
<li>}</li>
<li>}</li></ol>
</div>
<p>最后是执行测试了，写个主函数来运行：</p>
<div>
<ol><li>public&nbsp;static&nbsp;void&nbsp;main(String[]&nbsp;args)&nbsp;{</li>
<li>long&nbsp;start&nbsp;=&nbsp;System.currentTimeMillis();</li>
<li>generateExcel2007(xlsx2007);</li>
<li>long&nbsp;end&nbsp;=&nbsp;System.currentTimeMillis();</li>
<li>System.out.println((end&nbsp;-&nbsp;start)&nbsp;+&nbsp;"&nbsp;ms&nbsp;done!");</li>
<li>}</li></ol>
</div>
<p>将以上所有内容封装在静态方法generateExcel2007(String filePath)中，执行即可得到生成的Excel报表了，我们得到了这样的一个报表：&nbsp;<br /><img referrerpolicy="no-referrer"src="http://dl.iteye.com/upload/attachment/370540/6b5b9474-340b-33ba-942b-a89f1d8306f8.jpg" />&nbsp;<br />&nbsp;&nbsp;&nbsp; 这就是最终得到的结果了。POI操作Excel的基本设置就基本涵盖了，剩下的就是灵活运用，生成符合自己需求的报表了。&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://sarin.iteye.com/blog/853418" rel="external nofollow noreferrer">下一篇</a>将结合一个具体实例来介绍复杂报表的分析和制作，完成如下图所示的报表：&nbsp;<br /><img referrerpolicy="no-referrer"src="http://dl.iteye.com/upload/attachment/370542/a455d9c0-0863-3984-8a81-f9091bc329e0.jpg" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8e7j0z9.html">W3Cschool菜鸟教程离线版下载链接</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd1pgvq.html">JavaScript基础&mdash;&mdash;实现循环</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm5mp09.html">Java从入门到精通&mdash;&mdash;调错篇之ORACLE 打开PLSQL时提示ora-01033</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1gr3j8.html">eclipse中切换jre后报错：Java compiler level does not match the version of the installed Java project facet&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y633nq.html">vs&colon; 编译&colon; 计算机中丢失mspdb100&period;dll</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv7nrzq.html">12天学好C语言&mdash;&mdash;记录我的C语言学习之路（Day 6）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xkym68.html">最蛋疼的bug：读取图片缩略图（一定要在相冊查看下形成缓存）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wpzooq.html">UGUI 过渡动画插件&comma;模仿NGUI的Tween &lpar;转载&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oxy339.html">Lisp之根源</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmn1r09.html">LINUX查看硬件配置命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljelm69.html">2&period;3&period;9 用NPOI操作EXCEL－－通过NPOI获得公式的返回值</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meep42q.html">TCP和UDP的差别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1rr11q.html">java之反射</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gerje08.html">Laplace（拉普拉斯）先验与L1正则化</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mezr0rq.html">python 与rabbitmq</a>
		</li>
						<li><a href="https://www.batexi.com/a/9geyj648.html">SpringBoot多环境部署，在启动时动态设置相应的配置文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljrzdk9.html">java爬虫系列目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m6k1m8.html">go语言实现https的简单get和post请求</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgj1y48.html">20175320 2018-2019-2 《Java程序设计》第9周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy5zvjq.html">Sqlmap 中绕过空格拦截的12个脚本</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8k1xp539.html">讲解版的自动轮播（新手福利）样式和js就不分离了为了看的方便</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z10omd9.html">Linux RAR 安装和使用详细说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okm1ll9.html">swing入门例子</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v6roo8.html">Sftp和ftp 差别、工作原理等（汇总ing）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okm4g59.html">多路复用I&sol;O poll&lpar;&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/96ovm3y9.html">Linux下的压缩和解压</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm6ogk9.html">asp&period;net mvc 页面缓存</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm6n509.html">Eclipse搭建Android开发环境（安装ADT，Android4&period;4&period;2）（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/96ovdm39.html">CM3存储器系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxn7yrz8.html">JAVA GUI 工具</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
